<?php

$host = $argv[1];
isset($argv[2]) ? $community = $argv[2] : $community = 'public';
isset($argv[3]) ? $warn = $argv[3] : $warn = 10;
isset($argv[4]) ? $critical = $argv[4] : $critical = 5;

//Get ALL THE THINGS!
$snmp_objects = @snmprealwalk($host, $community, '');

//If the printer can't be reached, there is no sense in continuing past this point.
if(!isset($snmp_objects['iso.3.6.1.2.1.1.1.0'])){
    echo "Cannot reach the printer. Possibly offline.";
    exit(2);
}
$screen = @array_keys($snmp_objects);
$screen_text = array();

//Add to these as you see fit.
//Messages not accounted for will exit 0 and will show up as a green light in Nagios no matter what their real severity.
//Keep this list of status messages up to date.
//Good messages
$the_good = array('Sleep mode on', 'Calibrating', 'Ready', 'Processing', 'Checking', 'Printing');
//Warning level messages
$the_bad = array('Cartridge', 'Toner', 'Order');
//Critical messages
$the_ugly = array('Load', 'Tray', 'Jam', 'Intervention', 'Fuser', 'Replace', 'Install');

//Screen Text
$counter = 0;
if ($screen) {
    foreach ($screen as &$array_key) {
        if (strstr($array_key, 'iso.3.6.1.2.1.43.18.') && strstr($snmp_objects[$array_key], 'STRING')) {
            $screen_text[$counter] = str_replace('"', '', str_replace('STRING: "', '', $snmp_objects[$array_key])) . ' - ';
            $counter++;
        }
    }
}
//
//Toner
//
cartridges();
//
//Other Errors
//
$i = 0;
while ($i <= sizeof($screen_text) - 1) {
    if ($screen_text[$i]) {
        $return_string .= $screen_text[$i] . " - ";
    }
    $i++;
}

//
//Output
//
if ($return_string) {

    //Some garbage cleanup (Something that annoyed me about version 1)
    if (strstr($return_string, '-  -')) {
        $return_string = str_replace('-  -', '', $return_string);
    }

    //Parse for the critical stuff first
    messages($the_ugly, 2);
    //...if that passes, parse for warnings
    messages($the_bad, 1);
    //...if thats all good, parse for the good statuses
    messages($the_good, 0);

    //For things not accounted for in the good, the bad or the ugly...
    echo rtrim($return_string, ' - ');
    exit(0);
}
//If there is no status message, everything must be OK
else {
    echo "Printer OK";
    exit(0);
}

//(V.3) Re-Written in V.4
function cartridges() {
    global $warn, $critical, $snmp_objects, $return_string;
    $types = array('black', 'cyan', 'magenta', 'yellow');
    $carts = array( 'black_cart' => 'iso.3.6.1.2.1.43.11.1.1.6.1.1', 'cyan_cart' => 'iso.3.6.1.2.1.43.11.1.1.6.1.2', 'magenta_cart' => 'iso.3.6.1.2.1.43.11.1.1.6.1.3', 'yellow_cart' => 'iso.3.6.1.2.1.43.11.1.1.6.1.4', 'black_max' => 'iso.3.6.1.2.1.43.11.1.1.8.1.1', 'cyan_max' => 'iso.3.6.1.2.1.43.11.1.1.8.1.2', 'magenta_max' => 'iso.3.6.1.2.1.43.11.1.1.8.1.3', 'yellow_max' => 'iso.3.6.1.2.1.43.11.1.1.8.1.4', 'black_current' => 'iso.3.6.1.2.1.43.11.1.1.9.1.1', 'cyan_current' => 'iso.3.6.1.2.1.43.11.1.1.9.1.2', 'magenta_current' => 'iso.3.6.1.2.1.43.11.1.1.9.1.3', 'yellow_current' => 'iso.3.6.1.2.1.43.11.1.1.9.1.4');
    foreach ($types AS $type) {
        $cart = $carts[$type . "_cart"];
        $max = $carts[$type . "_max"];
        $current = $carts[$type . "_current"];
        if (array_key_exists($max, $snmp_objects)) {
            $percent = (actual_value($snmp_objects[$current]) / actual_value($snmp_objects[$max])) * 100;
            if ($percent <= $critical) {
                $return_string .= "Replace " . actual_string($snmp_objects[$cart]) . " - $percent% ";
            } else if ( $percent > $critical && $percent <= $warn) {
                $return_string .= "Order " . actual_string($snmp_objects[$cart]) . " - $percent% ";
            }
        }
    }
}

//(V.2)
function messages($array_name, $exit_code) {
    global $return_string;
    for ($i = 0; $i <= sizeof($array_name) - 1; $i++) {
        if (stristr($return_string, $array_name[$i])) {
            if ($exit_code == 0) {
                $return_string = "Printer OK - " . $return_string;
            }
            echo rtrim($return_string, ' - ');
            exit($exit_code);
        }
    }
}

//(V.4)
function actual_value($input) {
    return next(explode(' ', $input));
}

function actual_string($input) {
    return next(explode('"', $input));
}